version: '3.8'  # Versão do Docker Compose

services:
  rabbitmq:
    image: rabbitmq:3-management
    container_name: rabbitmq
    ports:
      - 15672:15672
    healthcheck:
      test: [ "CMD", "rabbitmqctl", "status" ]
      interval: 10s
      timeout: 5s
      retries: 5
  rabbitmq-init:
    depends_on:
      rabbitmq:
        condition: service_healthy
    build:
      dockerfile: Dockerfile
      context: rabbitmq
    environment:
      RABBITMQ_USER: guest
      RABBITMQ_PASSWORD: guest
      RABBITMQ_HOST: rabbitmq
      RABBITMQ_PORT: 5672
      RABBITMQ_HTTP_PORT: 15672
  mongodb:
    image: mongo
    environment:
      MONGO_INITDB_ROOT_USERNAME: guest
      MONGO_INITDB_ROOT_PASSWORD: guest
      MONGO_INITDB_DATABASE: catalogo-video
    volumes:
      - ./mongodb/init.js:/docker-entrypoint-initdb.d/mongo-init.js:ro
  catalogo-video:
    image: catalogo-video
    environment:
      - SPRING_PORT=80
      - DIRECTORY_VIDEOS=/tmp/videos
      - LOGGING_LEVEL_ROOT=DEBUG
      - RABBITMQ_HOST=rabbitmq
      - RABBITMQ_PORT=5672
      - RABBITMQ_USERNAME=guest
      - RABBITMQ_PASSWORD=guest
      - MONGODB_DATABASE=catalogo-video
      - MONGODB_URI=mongodb://guest:guest@mongodb:27017
  captura-video:
    image: captura-video
    restart: always
    environment:
      - SPRING_PORT=80
      - DIRECTORY_VIDEOS=/tmp/videos
      - LOGGING_LEVEL_ROOT=DEBUG
      - RABBITMQ_HOST=rabbitmq
      - RABBITMQ_PORT=5672
      - RABBITMQ_USERNAME=guest
      - RABBITMQ_PASSWORD=guest
      - MONGODB_DATABASE=catalogo-video
      - MONGODB_URI=mongodb://guest:guest@mongodb:27017
    volumes:
      - videos-volume:/tmp/videos
  captura-eventos:
    image: captura-eventos
    environment:
      - RABBITMQ_HOST=rabbitmq
      - RABBITMQ_PORT=5672
      - RABBITMQ_USERNAME=guest
      - RABBITMQ_PASSWORD=guest
      - QUARKUS_HTTP_PORT=80
      - QUARKUS_LOG_LEVEL=DEBUG
  portal:
    image: portal
    ports:
      - 8081:80
    volumes:
      - videos-volume:/var/www/html/videos  # Monta a pasta local 'videos' em '/var/www/html' no container

volumes:
  videos-volume:
    driver: local